<tool id="scale" name="SC" version="0.0.1">
  <description>  Scale </description>
  <requirements>
    <requirement type="package" version="5.0.0">scilab</requirement>
  </requirements>

  <command interpreter="bash">r_wrapper.sh $script_file</command>

  <inputs>
    <param name="Xdata"  format="tabular"  type="data" label="Select X data" help="Dataset (n x p) containing the n spectra of p variables."/>
    <param format="text" name="centering" type="select" label="Centering option">
      <option value="T" selected="true">yes</option>
      <option value="F">no</option>
    </param>
    <param format="text" name="scaling" type="select" label="Scaling option">
      <option value="T" >yes</option>
      <option value="F" selected="True" >no</option>
    </param>
  </inputs>

  <configfiles>
    <configfile name="script_file">
      ## Setup R error handling to go to stderr
      options( show.error.messages=F,
               error = function () { cat( geterrmessage(), file=stderr() ); q( "no", 1, F ) } )
      x = read.table( "${Xdata.file_name}",h=T,sep="\t")
      if(length(which(duplicated(x[,1])==T))>0) stop(paste(as.character(x[which(duplicated(x[,1])==T),1]),"replicated at line",which(duplicated(x[,1])==T),"  ")) else x = read.table("${Xdata.file_name}",h=T,sep="\t",row.names=1, strip.white=T,check.names=F)
      row.names(x)=gsub("^\\s+|\\s+$", "", row.names(x))
      #if (str($scaling)=="T")
       x2=scale(x,center=${centering},scale = apply(x, 2, sd, na.rm = TRUE))
      #elif (str($scaling)=="F")
        x2=scale(x,center = ${centering},scale = ${scaling})
      #end if
      write.table(x2, file = "${CT}", sep = "\t",quote=F,row.names = TRUE ,col.names = NA)
    </configfile>
  </configfiles>

  <outputs>
    <data name="CT" format="input" type="data" label="scale(${Xdata.name})" />
  </outputs>
  <tests>
    <test>
      <param name="Xdata" value="Xnir.tabular"/>
      <param name="degre" value="2" />
      <output name="DT" file="DT.tabular"/>
    </test>
  </tests>
<help>

.. class:: warningmark

**TIP:** If your data is not TAB delimited, use *Convert format data Tools-&gt;Convert*

.. class:: infomark

**Authors** Fabien Gogé (IRSTEA), Virginie Rossard (INRA), Eric Latrille (INRA), Jean-Michel Roger (IRSTEA), Jean-Claude Boulet (INRA)

-----


======
SCALE
======

-----------
Description
-----------

generic function whose default method centers and/or scales the columns of a numeric matrix.

-----------
Input files
-----------

Matrix of numeric data with headers (tabular format) and decimal separator ".".


+--------+-------+--------+
| Name   | 400   | 402    |
+========+=======+========+
|M102T645| 0.63  |0.64    |
+--------+-------+--------+
|M105T604| 0.5   |0.49    |
+--------+-------+--------+

----------
Parameters
----------

**Centering option**

If 'no': no centering of the variables

**Scaling option**

If 'no': no scaling of the variables

------------
Output files
------------

**SC(input.file_name)**
dataset containing the file input corrected by centering and/or scaling format tabular



</help>
</tool>
